package eu.mikroskeem.utils.etcdconnector;

import io.netty.handler.ssl.SslContext;
import io.netty.handler.ssl.SslContextBuilder;
import mousio.client.retry.RetryOnce;
import mousio.etcd4j.EtcdClient;
import org.slf4j.LoggerFactory;

import javax.net.ssl.SSLException;
import java.io.IOException;
import java.net.URI;

public class EtcdSSLConnector extends EtcdConnectorBase implements EtcdConnector {
    public EtcdSSLConnector(URI... etcdUrls) throws IOException {
        super();

        /* Set up logger */
        logger = LoggerFactory.getLogger(this.getClass());

        /* Initialize client */
        initClient(etcdUrls);

        /* Test client */
        testEtcd();
    }

    @Override void initClient(URI... urls){
        SslContext sslContext;
        try {
            //sslContext = SslContext.newClientContext();
            sslContext = SslContextBuilder.forClient().build();
        } catch (SSLException e){
            logger.error("Encountered error while creating new SSL context");
            throw new RuntimeException(e);
        }
        etcdClient = new EtcdClient(sslContext, urls);
        etcdClient.setRetryHandler(new RetryOnce(5000));
    }
}